slurmrestd(8)

NAME
slurmrestd - Interface to Slurm via REST API.

SYNOPSIS
slurmrestd [OPTIONS...] <[host]:port|unix:/path/to/socket>...

DESCRIPTION
slurmrestd is REST API interface for Slurm. It can be used in two modes:

Inetd Mode: slurmrestd will read and write to STDIO. If STDIN is a socket file descriptor, then slurmrestd will detect this and use relevant functionatlity. If a controlling TTY is detected, interactive mode will automatically activate to provide additional logging information. This mode is designed to work with piped input, inetd, xinetd or systemd socket activation.

Listen Mode: slurmrestd will open a listening socket on each requested host:port pair or UNIX socket.

OPTIONS

[host]:port
    Hostname and port to listen against. host may be an IPv4/IPv6 IP or a resolvable hostname. Hostnames are only looked up at startup and do not change for the life of the process. host is optional; if not provided, slurmrestd will listen on all network interfaces.

unix:/path/to/socket
    Listen on local UNIX socket. Must have permission to create socket in filesystem.

-a <authentication plugins>
    Comma-delimited list of authentication plugins to load. Default behavior is to load all REST authentication plugins found at load time.

    list
        Display a list of the possible plugins to load.

    rest_auth/local
        Allows authentication via UNIX sockets when auth/munge is active.
        NOTE: slurmrestd and client processes must run under the same UID or the client requests will be rejected.

    rest_auth/jwt
        Allows authentication via TCP and UNIX sockets when AuthAltTypes=auth/jwt is active. User must specify the following HTTP cookies with each request:

        X-SLURM-USER-NAME:<user name>

        X-SLURM-USER-TOKEN:<JSON Web Token>

        NOTE: Tokens are usually generated via calling "scontrol token".

-f <file>
    Read Slurm configuration from the specified file. See NOTES below.

-g <group id>
    Change group id (and drop supplemental groups) before processing client request. This should be a unique group with no write access or special permissions. Do not set this to the group belonging to to SlurmUser or root or the daemon won't start with the default settings.

-h  Help; print a brief summary of command options.

-s <OpenAPI plugins to load>
    Comma-delimited list of OpenAPI plugins. Set to "list" to dump a list of the possible plugins to load. Defaults: all builtin supported OpenAPI plugins.

-t <THREAD COUNT>
    Specify number of threads to use to process client connections. Ignored in inetd mode. Default: 20

-u <user id>
    Change user id before processing client request. This should be a unique group with no write access or special permissions. Do not set this user to SlurmUser or root or the daemon won't start with the default settings.

-v  Verbose operation. Multiple -v's increase verbosity. Higher verbosity levels will have significant performance impact.

-V  Print version information and exit.

ENVIRONMENT VARIABLES
The following environment variables can be used to override settings compiled into slurmctld.

SLURM_CONF
    The location of the Slurm configuration file.

SLURM_JWT
    This variable must be set to use JWT token authentication.

SLURMRESTD_AUTH_TYPES
    Set allowed authentication types. See -a

SLURMRESTD_DEBUG
    Set debug level explicitly. Valid values are 1-10. See -v

SLURMRESTD_LISTEN
    Comma-delimited list of host:port pairs or unix sockets to listen on.

SLURMRESTD_OPENAPI_PLUGINS
    Comma-delimited list of OpenAPI plugins to load. See -s

SLURMRESTD_SECURITY
    Control slurmrestd security functionality using the following comma-delimited values:

    disable_unshare_files
        Disables unsharing file descriptors with parent process.

    disable_unshare_sysv
        Disables unsharing the SYSV namespace.

    disable_user_check
        Disables check that slurmrestd is not running as root or SlurmUser, or with the root or SlurmUser's primary group.

SIGNALS

SIGINT
    slurmrestd will shutdown cleanly.

SIGPIPE
    This signal is explicitly ignored.

NOTES
SPANK and clifilter plugins are not supported in slurmrestd due to their lack of thread safety. Active SPANK plugins and JobSubmitPlugins in slurmctld are independent of slurmrestd and can be used to enforce site policy on job submissions.

COPYING
Copyright (C) 2019-2022 SchedMD LLC.

This file is part of Slurm, a resource management program. For details, see <https://slurm.schedmd.com/>.

Slurm is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.

Slurm is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

SEE ALSO
slurm.conf(5), slurmctld(8), slurmdbd(8)